## kuserfeedback 1.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(KUserFeedback VERSION 1.3.0)

find_package(ECM 5.26 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ ${ECM_MODULE_PATH} ${CMAKE_MODULE_PATH})

set(ENABLE_SURVEY_TARGET_EXPRESSIONS ON CACHE BOOL "Survey targeting expressions support is enabled by default.")
set(ENABLE_PHP                       ON CACHE BOOL "Syntax checking of PHP server code.")
set(ENABLE_PHP_UNIT                  ON CACHE BOOL "Unit tests for PHP server code.")
set(ENABLE_DOCS                      ON CACHE BOOL "Generate documentation.")
set(ENABLE_CONSOLE                   ON CACHE BOOL "Application console.")
set(ENABLE_CLI                       ON CACHE BOOL "Command line interface support.")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD 17)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(ECMGenerateHeaders)
include(ECMPoQmTools)
include(ECMSetupVersion)
include(ECMQueryQmake)
include(ECMGeneratePriFile)
include(FeatureSummary)
include(GenerateExportHeader)

if (ECM_VERSION VERSION_GREATER "5.68.0")
    include(ECMQtDeclareLoggingCategory)
endif()

MESSAGE(STATUS "ECM Version found: ${ECM_VERSION}")
set(KUSERFEEDBACK_EXTENSION)
if (QT_MAJOR_VERSION STREQUAL "6")
    set(KUSERFEEDBACK_EXTENSION "Qt6")
endif()

ecm_setup_version(PROJECT
    VARIABLE_PREFIX KUSERFEEDBACK
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kuserfeedback_version.h"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KUserFeedback${KUSERFEEDBACK_EXTENSION}ConfigVersion.cmake"
)
#
# Dependencies
#

find_package(Qt${QT_MAJOR_VERSION} 5.4 NO_MODULE REQUIRED COMPONENTS Core Network)
find_package(Qt${QT_MAJOR_VERSION} NO_MODULE QUIET OPTIONAL_COMPONENTS Widgets Charts Test Qml Svg PrintSupport)
find_package(QmlLint)

if (ENABLE_DOCS)
    if (NOT CMAKE_CROSSCOMPILING)
        find_package(Qt${QT_MAJOR_VERSION} NO_MODULE QUIET OPTIONAL_COMPONENTS Help)
    endif()

    if(QT_MAJOR_VERSION STREQUAL "5")
        find_package(Qt5 CONFIG OPTIONAL_COMPONENTS DocTools)
    else()
        find_package(Qt6 CONFIG OPTIONAL_COMPONENTS ToolsTools)
    endif()
endif()

set_package_properties(Qt${QT_MAJOR_VERSION} PROPERTIES URL "http://qt-project.org/")
set_package_properties(Qt${QT_MAJOR_VERSION}Widgets PROPERTIES TYPE RECOMMENDED PURPOSE "Required for feedback configuration and notification widgets.")
set_package_properties(Qt${QT_MAJOR_VERSION}Charts PROPERTIES TYPE RECOMMENDED PURPOSE "Required for UserFeedbackConsole.")

# debug suffixes for qmake compatibility
if(WIN32)
    set(CMAKE_DEBUG_POSTFIX "d")
elseif(APPLE)
    set(CMAKE_DEBUG_POSTFIX "_debug")
endif()

add_definitions(-DQT_USE_QSTRINGBUILDER -DQT_USE_FAST_OPERATOR_PLUS -DQT_NO_CAST_TO_ASCII -DQT_NO_URL_CAST_FROM_STRING -DQT_NO_CAST_FROM_ASCII)

if (ENABLE_SURVEY_TARGET_EXPRESSIONS)
    find_package(FLEX)
    set_package_properties(FLEX PROPERTIES TYPE RECOMMENDED PURPOSE "Survey target expression parser.")

    find_package(BISON)
    set_package_properties(BISON PROPERTIES TYPE RECOMMENDED PURPOSE "Survey target expression parser.")

    if(FLEX_FOUND AND BISON_FOUND)
        set(HAVE_SURVEY_TARGET_EXPRESSIONS 1)
    endif()
endif()
add_feature_info("Survey targeting expressions support" HAVE_SURVEY_TARGET_EXPRESSIONS "Requires flex and bison parser generators.")

if (ENABLE_PHP)
    find_package(Php)
    set_package_properties(Php PROPERTIES URL "http://php.net" TYPE RECOMMENDED PURPOSE "Syntax checking of PHP server code.")
endif()

if (ENABLE_PHP_UNIT)
    find_package(PhpUnit)
    set_package_properties(PhpUnit PROPERTIES URL "http://phpunit.de" TYPE RECOMMENDED PURPOSE "Unit tests for PHP server code.")
endif()

#
# Actually build the stuff
#
include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR})
configure_file(config-userfeedback.h.in ${CMAKE_CURRENT_BINARY_DIR}/config-userfeedback.h)

add_subdirectory(src)

if (BUILD_TESTING)
    add_subdirectory(autotests)

    add_subdirectory(tests)
endif()

if (ENABLE_DOCS)
    add_subdirectory(docs)
endif()

#
# CMake package config file generation
#
include(CMakePackageConfigHelpers)

if (${QT_MAJOR_VERSION} GREATER_EQUAL 6)
    set(_CONFIG_CMAKE_IN "KUserFeedbackConfig-Qt6.cmake.in")
else()
    set(_CONFIG_CMAKE_IN "KUserFeedbackConfig-Qt5.cmake.in")
endif()

configure_package_config_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/${_CONFIG_CMAKE_IN}
    ${CMAKE_CURRENT_BINARY_DIR}/KUserFeedback${KUSERFEEDBACK_EXTENSION}Config.cmake
    INSTALL_DESTINATION ${KDE_INSTALL_CMAKEPACKAGEDIR}/KUserFeedback
    PATH_VARS KDE_INSTALL_INCLUDEDIR
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/KUserFeedback${KUSERFEEDBACK_EXTENSION}Config.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/KUserFeedback${KUSERFEEDBACK_EXTENSION}ConfigVersion.cmake
    DESTINATION ${KDE_INSTALL_CMAKEPACKAGEDIR}/KUserFeedback${KUSERFEEDBACK_EXTENSION}
)

install(EXPORT KUserFeedback${KUSERFEEDBACK_EXTENSION}Targets DESTINATION ${KDE_INSTALL_CMAKEPACKAGEDIR}/KUserFeedback${KUSERFEEDBACK_EXTENSION} FILE KUserFeedback${KUSERFEEDBACK_EXTENSION}Target.cmake)

if (ECM_VERSION VERSION_GREATER "5.58.0")
    if (ECM_VERSION VERSION_GREATER "5.67.0")
        ecm_qt_install_logging_categories(
                EXPORT KUSERFEEDBACK
                FILE org_kde_UserFeedback.categories
                DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR}
                )
    else()
        install(FILES org_kde_UserFeedback.categories DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR})
    endif()
else()
    install(FILES org_kde_UserFeedback.categories DESTINATION ${KDE_INSTALL_CONFDIR})
endif()

ecm_install_po_files_as_qm(poqm)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

install(FILES
    ${KUserFeedbackCore_HEADERS}
    ${CMAKE_CURRENT_BINARY_DIR}/kuserfeedback_version.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KUserFeedback${KUSERFEEDBACK_EXTENSION}
)

=== tests/CMakeLists.txt ===
if(TARGET KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION} AND NOT (CMAKE_SOURCE_DIR EQUAL CMAKE_CURRENT_SOURCE_DIR))
    add_executable(feedbackconfigwidgettest feedbackconfigwidgettest.cpp)
    target_link_libraries(feedbackconfigwidgettest KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION})

    add_executable(notificationpopuptest notificationpopuptest.cpp)
    target_link_libraries(notificationpopuptest KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION})

    add_executable(orwell orwell.cpp orwell.h)
    target_link_libraries(orwell KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION})

    qml_lint(orwell.qml)
else()
    # stand-alone build for testing includes and cmake config
    message(STATUS "building test application stand-alone")
    set(CMAKE_AUTOMOC ON)
    set(CMAKE_AUTOUIC ON)
    set(CMAKE_INCLUDE_CURRENT_DIR ON)
    find_package(KUserFeedback${KUSERFEEDBACK_EXTENSION} REQUIRED)
    add_executable(orwell orwell.cpp)
    target_link_libraries(orwell KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION})
endif()

=== src/cli/CMakeLists.txt ===
set(uf_cli_srcs
    main.cpp
)

add_executable(userfeedbackctl ${uf_cli_srcs})
target_compile_features(userfeedbackctl PRIVATE cxx_generic_lambdas)
target_link_libraries(userfeedbackctl KUserFeedbackConsole)
install(TARGETS userfeedbackctl ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== src/common/CMakeLists.txt ===
set(common_src
    surveytargetexpression.cpp
    surveytargetexpressionevaluator.cpp
    surveytargetexpressionparser.cpp
    surveytargetexpression.h
    surveytargetexpressionevaluator.h
    surveytargetexpressionparser.h
)

if(HAVE_SURVEY_TARGET_EXPRESSIONS)

if (CMAKE_VERSION VERSION_LESS 3.5.0)
    set(_flex_opts COMPILE_FLAGS --nounistd --header-file=${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionscanner.h)
    set(_bison_opts COMPILE_FLAGS --defines=${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionparser_p.h)
else()
    set(_flex_opts COMPILE_FLAGS --nounistd DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionscanner.h)
    set(_bison_opts DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionparser_p.h)
endif()

flex_target(surveytargetexpressionscanner
    surveytargetexpressionlexer.l
    ${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionlexer.cpp
    ${_flex_opts}
)
bison_target(surveytargetexpressionparser
    surveytargetexpressionparser.y
    ${CMAKE_CURRENT_BINARY_DIR}/surveytargetexpressionparser_p.cpp
    ${_bison_opts}
)
add_flex_bison_dependency(surveytargetexpressionscanner surveytargetexpressionparser)
endif()

add_library(KUserFeedbackCommon STATIC
    ${common_src}
    ${BISON_surveytargetexpressionparser_OUTPUTS}
    ${FLEX_surveytargetexpressionscanner_OUTPUTS}
)
# Needed to link this static lib to shared libs
set_property(TARGET KUserFeedbackCommon PROPERTY POSITION_INDEPENDENT_CODE ON)

if (NOT BUILD_SHARED_LIBS)
    install(TARGETS KUserFeedbackCommon
            EXPORT KUserFeedback${KUSERFEEDBACK_EXTENSION}Targets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
endif()

target_include_directories(KUserFeedbackCommon PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_SOURCE_DIR}/..>")
target_link_libraries(KUserFeedbackCommon PUBLIC Qt${QT_MAJOR_VERSION}::Core)

=== src/console/CMakeLists.txt ===
ecm_create_qm_loader(userfeedback_console_QM_LOADER userfeedbackconsole5_qt)

set(console_lib_srcs
    core/aggregation.cpp
    core/aggregationelement.cpp
    core/product.cpp
    core/sample.cpp
    core/schemaentry.cpp
    core/schemaentryelement.cpp
    core/schemaentrytemplates.cpp
    core/survey.cpp

    rest/restapi.cpp
    rest/restclient.cpp
    rest/serverinfo.cpp

    jobs/job.cpp
    jobs/handshakejob.cpp
    jobs/productexportjob.cpp
    jobs/productimportjob.cpp
    jobs/securityscanjob.cpp

    model/aggregateddatamodel.cpp
    model/aggregationeditormodel.cpp
    model/aggregationelementmodel.cpp
    model/aggregationelementeditmodel.cpp
    model/categoryaggregationmodel.cpp
    model/datamodel.cpp
    model/extrarowsproxymodel.cpp
    model/numericaggregationmodel.cpp
    model/productmodel.cpp
    model/ratiosetaggregationmodel.cpp
    model/rolemappingproxymodel.cpp
    model/schemamodel.cpp
    model/singlerowfilterproxymodel.cpp
    model/surveymodel.cpp
    model/timeaggregationmodel.cpp

    core/aggregation.h
    core/aggregationelement.h
    core/product.h
    core/sample.h
    core/schemaentry.h
    core/schemaentryelement.h
    core/schemaentrytemplates.h
    core/survey.h

    rest/restapi.h
    rest/restclient.h
    rest/serverinfo.h

    jobs/job.h
    jobs/handshakejob.h
    jobs/productexportjob.h
    jobs/productimportjob.h
    jobs/securityscanjob.h

    model/aggregateddatamodel.h
    model/aggregationeditormodel.h
    model/aggregationelementmodel.h
    model/aggregationelementeditmodel.h
    model/categoryaggregationmodel.h
    model/datamodel.h
    model/extrarowsproxymodel.h
    model/numericaggregationmodel.h
    model/productmodel.h
    model/ratiosetaggregationmodel.h
    model/rolemappingproxymodel.h
    model/schemamodel.h
    model/singlerowfilterproxymodel.h
    model/surveymodel.h
    model/timeaggregationmodel.h

    schematemplates/schematemplates.qrc
)

add_library(KUserFeedbackConsole STATIC ${console_lib_srcs})
target_link_libraries(KUserFeedbackConsole Qt${QT_MAJOR_VERSION}::Network)
target_include_directories(KUserFeedbackConsole PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_SOURCE_DIR}/..>")
target_compile_features(KUserFeedbackConsole PRIVATE cxx_generic_lambdas)
target_compile_definitions(KUserFeedbackConsole PUBLIC QT_DISABLE_DEPRECATED_BEFORE=0x050600 QT_DEPRECATED_WARNINGS)

if(NOT TARGET KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION})
    return()
endif()

set(console_srcs
    connectdialog.cpp
    main.cpp
    mainwindow.cpp
    helpcontroller.cpp

    analytics/aggregator.cpp
    analytics/analyticsview.cpp
    analytics/categoryaggregator.cpp
    analytics/chartexportdialog.cpp
    analytics/chartutil.cpp
    analytics/numericaggregator.cpp
    analytics/ratiosetaggregator.cpp
    analytics/totalaggregator.cpp

    schemaeditor/aggregationeditwidget.cpp
    schemaeditor/schemaeditor.cpp
    schemaeditor/schemaeditwidget.cpp
    schemaeditor/schemaentryitemeditorfactory.cpp

    surveyeditor/surveydialog.cpp
    surveyeditor/surveyeditor.cpp

    widgets/metaenumcombobox.cpp

    connectdialog.h
    mainwindow.h
    helpcontroller.h

    analytics/aggregator.h
    analytics/analyticsview.h
    analytics/categoryaggregator.h
    analytics/chartexportdialog.h
    analytics/chartutil.h
    analytics/numericaggregator.h
    analytics/ratiosetaggregator.h
    analytics/totalaggregator.h

    schemaeditor/aggregationeditwidget.h
    schemaeditor/schemaeditor.h
    schemaeditor/schemaeditwidget.h
    schemaeditor/schemaentryitemeditorfactory.h

    surveyeditor/surveydialog.h
    surveyeditor/surveyeditor.h

    widgets/metaenumcombobox.h

    ${userfeedback_console_QM_LOADER}
)

add_executable(KUserFeedbackConsoleApplication ${console_srcs})
target_compile_features(KUserFeedbackConsoleApplication PRIVATE cxx_generic_lambdas)
set_target_properties(KUserFeedbackConsoleApplication PROPERTIES OUTPUT_NAME UserFeedbackConsole)
target_link_libraries(KUserFeedbackConsoleApplication
    Qt${QT_MAJOR_VERSION}::Widgets
    Qt${QT_MAJOR_VERSION}::Network
    Qt${QT_MAJOR_VERSION}::Charts
    Qt${QT_MAJOR_VERSION}::PrintSupport
    Qt${QT_MAJOR_VERSION}::Svg
    KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION}
    KUserFeedbackConsole
    KUserFeedbackCommon
)

install(TARGETS KUserFeedbackConsoleApplication ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
if(UNIX AND NOT APPLE)
    install(FILES org.kde.kuserfeedback-console.desktop DESTINATION ${KDE_INSTALL_APPDIR})
    install(FILES org.kde.kuserfeedback-console.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
endif()

=== src/provider/CMakeLists.txt ===
include(KDEFrameworkCompilerSettings)
add_subdirectory(core)
if(TARGET Qt${QT_MAJOR_VERSION}::Widgets)
  add_subdirectory(widgets)
endif()
if(TARGET Qt${QT_MAJOR_VERSION}::Qml)
  add_subdirectory(qml)
endif()

=== src/provider/core/CMakeLists.txt ===
ecm_create_qm_loader(userfeedback_core_QM_LOADER userfeedbackprovider5_qt)

if (ECM_VERSION VERSION_GREATER "5.67.0")
ecm_qt_declare_logging_category(userfeedback_core_debug_srcs HEADER logging_p.h IDENTIFIER KUserFeedback::Log CATEGORY_NAME org.kde.UserFeedback
    DESCRIPTION "User Feedback Framework" EXPORT KUSERFEEDBACK)
else()
    set(userfeedback_core_debug_srcs
        logging_p.cpp
        logging_p.h)
endif()

set(userfeedback_core_srcs
    abstractdatasource.cpp
    applicationversionsource.cpp
    compilerinfosource.cpp
    cpuinfosource.cpp
    feedbackconfiguicontroller.cpp
    localeinfosource.cpp
    openglinfosource.cpp
    platforminfosource.cpp
    propertyratiosource.cpp
    provider.cpp
    qpainfosource.cpp
    qtversionsource.cpp
    screeninfosource.cpp
    selectionratiosource.cpp
    startcountsource.cpp
    surveyinfo.cpp
    usagetimesource.cpp
    auditloguicontroller.cpp

    abstractdatasource.h
    applicationversionsource.h
    compilerinfosource.h
    cpuinfosource.h
    feedbackconfiguicontroller.h
    localeinfosource.h
    openglinfosource.h
    platforminfosource.h
    propertyratiosource.h
    provider.h
    qpainfosource.h
    qtversionsource.h
    screeninfosource.h
    selectionratiosource.h
    startcountsource.h
    surveyinfo.h
    usagetimesource.h
    auditloguicontroller.h
    ${userfeedback_core_QM_LOADER}
    ${userfeedback_core_debug_srcs}
)



add_library(KUserFeedbackCore${KUSERFEEDBACK_EXTENSION} ${userfeedback_core_srcs})
set_target_properties(KUserFeedbackCore${KUSERFEEDBACK_EXTENSION} PROPERTIES
    SOVERSION ${KUSERFEEDBACK_SOVERSION}
    VERSION ${KUSERFEEDBACK_VERSION}
)
generate_export_header(KUserFeedbackCore${KUSERFEEDBACK_EXTENSION} BASE_NAME KUserFeedbackCore)

target_link_libraries(KUserFeedbackCore${KUSERFEEDBACK_EXTENSION} PUBLIC Qt${QT_MAJOR_VERSION}::Core PRIVATE Qt${QT_MAJOR_VERSION}::Gui Qt${QT_MAJOR_VERSION}::Network)
if(ANDROID)
    target_link_libraries(KUserFeedbackCore${KUSERFEEDBACK_EXTENSION} PRIVATE GLESv2)
endif()
target_compile_definitions(KUserFeedbackCore${KUSERFEEDBACK_EXTENSION} PRIVATE QT_DISABLE_DEPRECATED_BEFORE=0x050300)
target_link_libraries(KUserFeedbackCore${KUSERFEEDBACK_EXTENSION} PRIVATE KUserFeedbackCommon)
target_include_directories(KUserFeedbackCore${KUSERFEEDBACK_EXTENSION} PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_BINARY_DIR}>")
target_include_directories(KUserFeedbackCore${KUSERFEEDBACK_EXTENSION} INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/KUserFeedback${KUSERFEEDBACK_EXTENSION};${KDE_INSTALL_INCLUDEDIR}>")

ecm_generate_headers(KUserFeedbackCore_HEADERS
    HEADER_NAMES
        AbstractDataSource
        ApplicationVersionSource
        CompilerInfoSource
        CpuInfoSource
        LocaleInfoSource
        OpenGLInfoSource
        PlatformInfoSource
        PropertyRatioSource
        Provider
        QPAInfoSource
        QtVersionSource
        ScreenInfoSource
        StartCountSource
        SurveyInfo
        UsageTimeSource
        FeedbackConfigUiController
    REQUIRED_HEADERS KUserFeedbackCore_HEADERS
)

install(TARGETS KUserFeedbackCore${KUSERFEEDBACK_EXTENSION} EXPORT KUserFeedback${KUSERFEEDBACK_EXTENSION}Targets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES
    ${KUserFeedbackCore_HEADERS}
    ${CMAKE_CURRENT_BINARY_DIR}/kuserfeedbackcore_export.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KUserFeedback${KUSERFEEDBACK_EXTENSION}
)

ecm_generate_pri_file(BASE_NAME KUserFeedbackCore${KUSERFEEDBACK_EXTENSION}
                      LIB_NAME KUserFeedbackCore${KUSERFEEDBACK_EXTENSION}
                      DEPS "core network"
                      FILENAME_VAR PRI_FILENAME
)

install(FILES ${PRI_FILENAME} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})

=== src/provider/qml/CMakeLists.txt ===
set(provider_qml_srcs
    qmlabstractdatasource.cpp
    qmldatasources.cpp
    qmlplugin.cpp
    qmlpropertyratiosource.cpp
    qmlproviderextension.cpp
    qmlpropertysource.cpp

    qmlabstractdatasource.h
    qmldatasources.h
    qmlplugin.h
    qmlpropertyratiosource.h
    qmlproviderextension.h
    qmlpropertysource.h
)

configure_file(qmldir.in ${CMAKE_CURRENT_BINARY_DIR}/qmldir)

add_library(KUserFeedbackQml${KUSERFEEDBACK_EXTENSION} SHARED ${provider_qml_srcs})

target_link_libraries(KUserFeedbackQml${KUSERFEEDBACK_EXTENSION}
    KUserFeedbackCore${KUSERFEEDBACK_EXTENSION}
    Qt${QT_MAJOR_VERSION}::Qml
)

install(TARGETS KUserFeedbackQml${KUSERFEEDBACK_EXTENSION} DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/userfeedback)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qmldir DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/userfeedback)

=== src/provider/widgets/CMakeLists.txt ===
set(userfeedback_widgets_srcs
    feedbackconfigdialog.cpp
    feedbackconfigwidget.cpp
    notificationpopup.cpp
    styleinfosource.cpp
    auditlogbrowserdialog.cpp

    feedbackconfigdialog.h
    feedbackconfigwidget.h
    notificationpopup.h
    styleinfosource.h
    auditlogbrowserdialog.h
)

add_library(KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION} ${userfeedback_widgets_srcs})
set_target_properties(KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION} PROPERTIES
    SOVERSION ${KUSERFEEDBACK_SOVERSION}
    VERSION ${KUSERFEEDBACK_VERSION}
)
generate_export_header(KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION} BASE_NAME KUserFeedbackWidgets)
if(TARGET Qt${QT_MAJOR_VERSION}::Widgets)
    target_link_libraries(KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION} PUBLIC Qt${QT_MAJOR_VERSION}::Widgets KUserFeedbackCore${KUSERFEEDBACK_EXTENSION})
else()
    target_link_libraries(KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION} PUBLIC ${QT_QTGUI_LIBRARIES} KUserFeedbackCore${KUSERFEEDBACK_EXTENSION})
endif()
target_include_directories(KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION} PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_BINARY_DIR}>")
target_include_directories(KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION} INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/KUserFeedback${KUSERFEEDBACK_EXTENSION};${KDE_INSTALL_INCLUDEDIR}>")

ecm_generate_headers(KUserFeedbackWidgets_HEADERS
    HEADER_NAMES
        FeedbackConfigDialog
        FeedbackConfigWidget
        NotificationPopup
        StyleInfoSource
    REQUIRED_HEADERS KUserFeedbackWidgets_HEADERS
)

install(TARGETS KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION} EXPORT KUserFeedback${KUSERFEEDBACK_EXTENSION}Targets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES
    ${KUserFeedbackWidgets_HEADERS}
    ${CMAKE_CURRENT_BINARY_DIR}/kuserfeedbackwidgets_export.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/KUserFeedback${KUSERFEEDBACK_EXTENSION}
)

ecm_generate_pri_file(BASE_NAME KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION}
                      LIB_NAME KUserFeedbackWidgets${KUSERFEEDBACK_EXTENSION}
                      DEPS "KUserFeedbackCore widgets"
                      FILENAME_VAR PRI_FILENAME
)

install(FILES ${PRI_FILENAME} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})

=== debian/changelog ===
kuserfeedback (1.3.0-9) unstable; urgency=medium

  * Team upload.
  * CI: update/simplify configuration.
  * Backport upstream commit dc507c18a2c6c857b1202e20fa91729d724e270e to make
    it possible to disable testOpenGLInfoSource using an environment variable;
    patch upstream_tests-allow-to-disable-testOpenGLInfoSource-using-en.patch.
  * Export KUSERFEEBACK_SKIP_TESTOPENGLINFOSOURCE=1 in rules to skip the
    testOpenGLInfoSource test, as creating an OpenGL context is not reliable
    on buildds.
  * Run the tests at build time again, now that testOpenGLInfoSource is skipped.
  * Bump Standards-Version to 4.7.0, no changes required.
  * Update symbols files for GCC 14.
  * Since certain components are no more shipped, simplify the build a bit:
    - drop the different cmake invocations for -arch and -indep builds, and
      unconditionally disable the documentation
    - pass -DENABLE_CONSOLE=OFF to stop building UserFeedbackConsole altogether
    - pass -DENABLE_CLI=OFF to stop building userfeedbackctl altogether
    - drop almost all the content in debian/not-installed
  * Drop install files of packages that are no more shipped.

 -- Pino Toscano <pino@debian.org>  Fri, 23 Aug 2024 18:12:02 +0200

kuserfeedback (1.3.0-8) unstable; urgency=medium

  * Team upload.

  [ Patrick Franz ]
  * Upload to unstable for real this time.

 -- Patrick Franz <deltaone@debian.org>  Thu, 18 Jul 2024 19:04:27 +0200

kuserfeedback (1.3.0-7) experimental; urgency=medium

  * Team upload.

  [ Patrick Franz ]
  * Upload to unstable.

 -- Patrick Franz <deltaone@debian.org>  Thu, 18 Jul 2024 18:38:43 +0200

kuserfeedback (1.3.0-6) experimental; urgency=medium

  [ Patrick Franz ]
  * Team upload.
  * Rebuild with tests disabled.

 -- Patrick Franz <deltaone@debian.org>  Tue, 18 Jun 2024 21:22:21 +0200

kuserfeedback (1.3.0-5) unstable; urgency=medium

  [ Patrick Franz ]
  * Team upload.
  * Disable tests.

 -- Patrick Franz <deltaone@debian.org>  Tue, 18 Jun 2024 08:57:35 +0200

kuserfeedback (1.3.0-4) experimental; urgency=medium

  * Revert "build also qt6 libraries", the qt6 binaries are now provided by
    the kf6-kuserfeedback source package.
  * Drop -bin and -doc packages that are now provided by the kf6 source
    package.

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 16 Apr 2024 23:17:46 +0200

kuserfeedback (1.3.0-3) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Pino Toscano <pino@debian.org>  Wed, 08 Nov 2023 07:05:26 +0100

kuserfeedback (1.3.0-2) experimental; urgency=medium

  * Team upload.
  * Split the localization files from libkuserfeedbackcore1 to a new
    libkuserfeedback-l10n, as they will be useful also for the Qt 6 version
    - add proper breaks/replaces
  * Build the Qt 6 libraries:
    - add the qt6-base-dev, qt6-declarative-dev, and qt6-tools-dev build
      dependencies
    - do not build the console and the command line utilities, as they conflict
      with the Qt 5 versions
    - add new configure, build, and test steps for a separate Qt 6 variant
    - add new qt6-kuserfeedback-dev, libkuserfeedbackcoreqt6-1,
      libkuserfeedbackwidgetsqt6-1, and qml6-module-org-kde-userfeedback
      binary packages as counterparts of their Qt 5 versions
  * Tweak the descriptions of all the Qt 5 packages to mention the Qt version.

 -- Pino Toscano <pino@debian.org>  Sat, 04 Nov 2023 18:16:52 +0100

kuserfeedback (1.3.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update standards version to 4.6.2, no changes needed.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.16
  * Small copyright update.
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Fri, 03 Nov 2023 08:24:58 +0100

=== debian/control ===
Source: kuserfeedback
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Scarlett Moore <sgmoore@kde.org>, Sandro Knauß <hefee@debian.org>,
Build-Depends: bison,
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.51.0~),
               flex,
               libqt5charts5-dev,
               libqt5svg5-dev,
               pkg-kde-tools (>= 0.15.15ubuntu1~),
               qtbase5-dev (>= 5.8.0~),
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qttools5-dev,
               qttools5-dev-tools (>= 5.4),
               xauth <!nocheck>,
               xvfb <!nocheck>,
Build-Depends-Indep: qdoc-qt5
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://invent.kde.org/libraries/kuserfeedback
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kuserfeedback
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kuserfeedback.git

Package: libkuserfeedback-l10n
Section: localization
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Breaks: libkuserfeedbackcore1 (<< 1.3.0-2~),
Replaces: libkuserfeedbackcore1 (<< 1.3.0-2~),
Description: user feedback for applications - localization files
 Framework for collecting user feedback for applications via telemetry
 and surveys.
 .
 Telemetry
  * Extensible set of data sources for telemetry.
  * Full control for the user on what data to contribute.
 Surveys
  * Distribute surveys and offer users to participate in them.
  * Survey targeting based on telemetry data.
  * Allow the user to configure how often they want to participate in surveys.
 .
 This package contains the shared localizations for KUserFeedback.

Package: kuserfeedback-dev
Section: libdevel
Architecture: any
Depends: libkuserfeedbackcore1 (= ${binary:Version}),
         libkuserfeedbackwidgets1 (= ${binary:Version}),
         qtbase5-dev,
         ${misc:Depends},
Description: development files for KUserFeedback - Qt 5 version
 Framework for collecting user feedback for applications via telemetry
 and surveys.
 .
 Telemetry
  * Extensible set of data sources for telemetry.
  * Full control for the user on what data to contribute.
 Surveys
  * Distribute surveys and offer users to participate in them.
  * Survey targeting based on telemetry data.
  * Allow the user to configure how often they want to participate in surveys.
 .
 This package contains the development header files for the Qt 5 version of
 KUserFeedback.

Package: libkuserfeedbackcore1
Architecture: any
Multi-Arch: same
Depends: libkuserfeedback-l10n (>= ${source:Version}),
         ${misc:Depends}, ${shlibs:Depends}
Description: user feedback for applications - Qt 5 core library
 Framework for collecting user feedback for applications via telemetry
 and surveys.
 .
 Telemetry
  * Extensible set of data sources for telemetry.
  * Full control for the user on what data to contribute.
 Surveys
  * Distribute surveys and offer users to participate in them.
  * Survey targeting based on telemetry data.
  * Allow the user to configure how often they want to participate in surveys.
 .
 This package contains the core library for the Qt 5 version of KUserFeedback.

Package: libkuserfeedbackwidgets1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: qml-module-org-kde-userfeedback (= ${binary:Version})
Description: user feedback for applications - Qt 5 widgets library
 Framework for collecting user feedback for applications via telemetry
 and surveys.
 .
 Telemetry
  * Extensible set of data sources for telemetry.
  * Full control for the user on what data to contribute.
 Surveys
  * Distribute surveys and offer users to participate in them.
  * Survey targeting based on telemetry data.
  * Allow the user to configure how often they want to participate in surveys.
 .
 This package contains the widgets library used by the Qt 5 version of
 KUserFeedback.

Package: qml-module-org-kde-userfeedback
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: user feedback for applications - Qt 5 QML module
 Framework for collecting user feedback for applications via telemetry
 and surveys.
 .
 Telemetry
  * Extensible set of data sources for telemetry.
  * Full control for the user on what data to contribute.
 Surveys
  * Distribute surveys and offer users to participate in them.
  * Survey targeting based on telemetry data.
  * Allow the user to configure how often they want to participate in surveys.
 .
 This package contains the QML module for the Qt 5 version of KUserFeedback.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# do not run testOpenGLInfoSource during builds
export KUSERFEEBACK_SKIP_TESTOPENGLINFOSOURCE=1

%:
	dh $@ --with kf5,pkgkde_symbolshelper --buildsystem kf5 --without build_stamp

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_DOCS=OFF -DENABLE_CONSOLE=OFF -DENABLE_CLI=OFF -DQT_MAJOR_VERSION=5

override_dh_auto_test:
	xvfb-run dh_auto_test --no-parallel
